﻿using UnityEngine;
using System.Collections;

public class CameraFollow3 : MonoBehaviour 
{
	public GameObject target;

	public float smoothTime = 0.1f;
	public bool cameraFollowX = true;
	public bool cameraFollowY = true;
	public bool cameraFollowHeight = true;
	public float cameraHeight = 2.5f;
	public Vector2 velocity;
	public bool fallingScene = false;

	private Transform thisTransform;
	// Use this for initialization
	void Start () 
	{
		thisTransform = transform;
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(cameraFollowX)
		{
			thisTransform.position = new Vector3(Mathf.SmoothDamp(thisTransform.position.x, target.transform.position.x, 
			                                                      ref velocity.x, smoothTime), thisTransform.position.y, 
			                                     				  thisTransform.position.z);
		}

		if(fallingScene)
		{
			thisTransform.position = new Vector3(thisTransform.position.x, Mathf.SmoothDamp(thisTransform.position.y, target.transform.position.y -4, 
			                                                                                ref velocity.y, smoothTime), thisTransform.position.z);			                                                   
		}
		else if(cameraFollowY)
		{
			thisTransform.position = new Vector3(thisTransform.position.x, Mathf.SmoothDamp(thisTransform.position.y, target.transform.position.y + 1, 
			                                                                                ref velocity.y, smoothTime), thisTransform.position.z);			                                                   
		}
	}
}
